unit PDJScrollBar;



// TPDJScrollBar version 1.00
// Freeware Component for Delphi3 -> Delphi5
// Copyright  2000-2001 by Peric
// Birthday of Component 22.05.2001.
// E-mail: pericddn@ptt.yu
// If I' find any error or rubbish in TPDJScrollBar please send me Your suggest or Reclamation.

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
  ,MMSystem,ExtCtrls,StdCtrls,Buttons,DsgnIntf,ShellApi;

    {$R PDJScrollBar.Res}

//******************************************************************************
{TOK }
type
  TOK = class(TButton)
  protected
    procedure Click;override;
  end;
//******************************************************************************
{TMail }
type
  TMail = class(TCustomLabel)
  protected
    procedure Click;override;
  end;
//******************************************************************************
{TAbout }
type
  TAboutBoxObject = class(TObject);
  TAboutBoxEditor = class(TPropertyEditor)
  private
  BMP:TBitmap;
  function GetAttributes: TPropertyAttributes; override;
  function GetValue: string; override;
  procedure Edit; override;
  end;

//******************************************************************************
{TTraka }
  type
  TTraka = class(TCustomPanel)
 private
    FXX,FYY:integer;
    FRepeat: TTimer;
    FStart:  TTimer;
    procedure doRepeat(Sender: TObject);
    procedure doStart(Sender: TObject);
    procedure WMLButtonDblClk (var Message: TWMLButtonDown); message WM_LBUTTONDBLCLK;
    procedure CMMouseLeave(var AMsg: TMessage);message CM_MOUSELEAVE;
  protected
    procedure Click;override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy; override;

  end;
  
//******************************************************************************
{TButtonUp }
  type
  TButtonUp = class(TSpeedButton)
 private
    FRepeat: TTimer;
    FStart:  TTimer;
    procedure doRepeat(Sender: TObject);
    procedure doStart(Sender: TObject);
    procedure WMLButtonDblClk (var Message: TWMLButtonDown); message WM_LBUTTONDBLCLK;
  protected
    procedure Click;override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy; override;

  end;

//******************************************************************************
{TButtonDown }
  type
  TButtonDown = class(TSpeedButton)
 private
    FRepeat: TTimer;
    FStart:  TTimer;
    procedure doRepeat(Sender: TObject);
    procedure doStart(Sender: TObject);
    procedure WMLButtonDblClk (var Message: TWMLButtonDown); message WM_LBUTTONDBLCLK;
  protected
    procedure Click;override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy; override;
  end;

//******************************************************************************
{TSetac}
  type
  TSetac = class(TCustomPanel)
  private
    FDown: Boolean;
    FOldX, FOldY: Integer;
    FTopLimit: Integer;
    FBottomLimit: Integer;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
     X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
     X, Y: Integer); override;
  public
  end;

//******************************************************************************

type
  TOnScroll = procedure (Sender: TObject; ScrollPos: Integer) of object;
  TKind = (sbHorizontal,sbVertical);
  Tkoliki = 10..100;
  TTrk = 1..32767;
type
  TScroller = class(TCustomPanel)
  private
    FTrk:TTrk;
    FBojaSetaca,FBojaTrake:Tcolor;
    FTraka:TTraka;
    FPosition,FMax,FMin:Integer;
    FKoliki:Tkoliki;
    FSetac:TSetac;
    FOnScroll: TOnScroll;
    FKind:TKind;
    procedure SetTrk(value:TTrk);
    procedure SetBojaSetaca(ABojaSetaca:TColor);
    procedure SetBojaTrake(ABojaTrake:TColor);
    procedure SetKoliki(value:Tkoliki);
    procedure SetMax(Value: Integer);
    procedure SetMin(Value: Integer);
    procedure SetKind(Value:TKind);
    function ThumbFromPosition: Integer;
    function PositionFromThumb: Integer;
    procedure SetPosition(Value: Integer);
    procedure DoPositionChange;
    procedure DoScroll;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
  protected

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Trk:TTrk read FTrk write SetTrk default 1;
    property BojaSetaca:TColor read FBojaSetaca write SetBojaSetaca default ClBtnFace;
    property Bojatrake:TColor read FBojatrake write SetBojatrake default clBtnFace;
    property ThumbSize:Tkoliki read Fkoliki write SetKoliki default 25;
    property Min: Integer read FMin write SetMin;
    property Max: Integer read FMax write SetMax;
    property Kind:TKind read FKind write SetKind;
    property OnScroll: TOnScroll read FOnScroll write FOnScroll;
    property Position: Integer read FPosition write SetPosition;
    property Align;
    property Color;
    property Visible;
    property Enabled;
    property ParentColor default True;
  end;

//******************************************************************************
{TPDJScrollBar}
type
  TStep = 1..32767;
  TOnMouseOverEvent = procedure(Sender: TObject) of object;
  TOnMouseOutEvent = procedure(Sender: TObject) of object;
  TKindd = (tbHorizontal,tbVertical);
  TPDJScrollBar = class(TCustomPanel)
  private
    FAbout:TAboutBoxObject;
    FHintTwo:String;
    FOnMouseOver: TOnMouseOverEvent;
    FOnMouseOut: TOnMouseOutEvent;
    FStep:TStep;
    FButtonUp:TButtonUp;
    FButtonDown:TButtonDown;
    FKindd:TKindd;
    FScroller:TScroller;
    function  GetBojaSetaca:TColor;
    procedure SetBojaSetaca(value:TColor);
    function  GetBojaTrake:TColor;
    procedure SetBojaTrake(value:TColor);
    procedure SetStep(value:TStep);
    function  GetThumbSize:Tkoliki;
    procedure SetThumbSize(value:Tkoliki);
    function  GetTrk:TTrk;
    procedure SetTrk(value:TTrk);
    function  GetPosition:integer;
    procedure SetPosition(value:integer);
    function  GetMax:integer;
    procedure SetMax(value:integer);
    function  GetMin:integer;
    procedure SetMin(value:integer);
    function  GetOnChange: TOnScroll;
    procedure GetMinic(Sender:Tobject);
    procedure GetMaxic(Sender:Tobject);
    procedure GetTrkPlus(Sender:Tobject);
    procedure GetTrkMinus(Sender:Tobject);
    procedure SetOnChange(Value: TOnScroll);
    procedure SetKindd(Value:TKindd);

    function GetOnButtonUpClick: TNotifyEvent;
    procedure SetOnButtonUpClick(Value: TNotifyEvent);
    function GetOnButtonDownClick: TNotifyEvent;
    procedure SetOnButtonDownClick(Value: TNotifyEvent);

    function  GetHintTwo: string;
    procedure SetHintTwo(AHintTwo: string);

    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMSize(var Message: TMessage); message WM_SIZE;
    procedure CmEnabledChanged(var Message: TWmNoParams); message CM_ENABLEDCHANGED;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure CMMouseEnter(var AMsg: TMessage);
      message CM_MOUSEENTER;
    procedure CMMouseLeave(var AMsg: TMessage);
      message CM_MOUSELEAVE;
    
  protected
    procedure DoEnter; override;
    procedure DoExit; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property About:TAboutBoxObject read FAbout write FAbout;
    property HintSecondLine:string read GetHintTwo  write SetHintTwo;
    property OnClickBtnLT: TNotifyEvent read GetOnButtonUpClick write SetOnButtonUpClick;
    property OnClickBtnRD: TNotifyEvent read GetOnButtonDownClick write SetOnButtonDownClick;
    property OnMouseEnter: TOnMouseOverEvent read FOnMouseOver write FOnMouseOver;
    property OnMouseExit: TOnMouseOutEvent read FOnMouseOut write FOnMouseOut;
    property SmallChange:TStep read FStep write SetStep default 1;
    property LargeChange:TTrk read GetTrk write SetTrk default 1;
    property ColorThumb:TColor read GetBojaSetaca write SetBojaSetaca default ClBtnFace;
    property ColorBand:TColor read GetBojaTrake write SetBojaTrake default cl3DLight;
    property ThumbSize:Tkoliki read GetThumbSize write SetThumbSize;
    property Min:integer read GetMin write SetMin;
    property Max:integer read GetMax write SetMax;
    property Position:integer read GetPosition write SetPosition;
    property Kind:TKindd read FKindd write SetKindd;
    property OnChange: TOnScroll read GetOnChange write SetOnChange;
    property Color default cl3DLight;
    property Align;
    property Visible;
    property Enabled;
    property Hint;
    property ShowHint;
    property ParentColor;
    property TabStop default True;
    property TabOrder;
    property OnEnter;
    property OnExit;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property DragCursor;
    property DragMode;
    property PopupMenu;


  end;

procedure Register;

implementation
var levo,desno:Tbitmap;
AMsgDialog: TForm;


procedure Register;
begin
  RegisterComponents('PDJ', [TPDJScrollBar]);
  RegisterPropertyEditor(TypeInfo(TAboutBoxObject),nil,'', TAboutBoxEditor);
end;

constructor TPDJScrollBar.Create(AOwner: TComponent);

begin
inherited Create(AOwner);
SetBounds(0,0,130,21);
Color:=cl3DLight;
BevelOuter:=bvNone;
FStep:=1;
Caption:=' ';
TabStop:=True;


levo:=Tbitmap.Create;
desno:=Tbitmap.Create;
levo.Handle := LoadBitmap(hInstance, 'levoScrollBar');
desno.Handle := LoadBitmap(hInstance, 'desnoScrollBar');
FButtonUp:=TButtonUp.Create(Self);
with FButtonUp do
begin
flat:=true;
glyph.Assign(levo);
end;
InsertControl(FButtonUp);
FScroller:=TScroller.Create(Self);
InsertControl(FScroller);
FButtonDown:=TButtonDown.Create(Self);
with FButtonDown do
begin
flat:=true;
glyph.Assign(Desno);
end;
InsertControl(FButtonDown);
ControlStyle:= ControlStyle - [csAcceptsControls];
end;



procedure TPDJScrollBar.WMSize(var Message: TMessage);
begin
Case FKindd of
tbHorizontal:
begin
levo.Handle := LoadBitmap(hInstance, 'levoScrollBar');
desno.Handle := LoadBitmap(hInstance, 'desnoScrollBar');
FbuttonUp.SetBounds(0,0,15,height);
FbuttonUp.glyph.Assign(levo);
  FButtonDown.SetBounds((Width-15),0,15,height);
FbuttonDown.glyph.Assign(desno);
FScroller.SetBounds(15,0,(Width-30),(Height));
end;
tbVertical:
begin
levo.Handle := LoadBitmap(hInstance, 'goreScrollbar');
desno.Handle := LoadBitmap(hInstance, 'doleScrollbar');
FbuttonUp.SetBounds(0,0,Width,15);
FScroller.SetBounds(0,15,(Width),(Height-30));
 FbuttonUp.glyph.Assign(levo);
FButtonDown.SetBounds(0,(Height-15),Width,15);
 FbuttonDown.glyph.Assign(desno);
end;
end;

end;




destructor TPDJScrollBar.Destroy;
begin
FButtonUp.Free;
FButtonDown.Free;
FScroller.Free;
inherited Destroy;
end;

function TPDJScrollBar.GetHintTwo: string;
begin
     Result:=FHintTwo;
end;



procedure TPDJScrollBar.SetHintTwo(AHintTwo:String);
begin
FHintTwo:=AHintTwo;
if csDesigning in ComponentState then
 Exit;
  if hint<>'' then
  if FHintTwo<>'' then
hint:=hint+#13+FHintTwo else
hint:=hint;
end;

function TPDJScrollBar.GetOnButtonUpClick: TNotifyEvent;
begin
  Result := FButtonUp.OnClick;
end;

procedure TPDJScrollBar.SetOnButtonUpClick(Value: TNotifyEvent);
begin
FButtonUp.OnClick:= value;
end;

function TPDJScrollBar.GetOnButtonDownClick: TNotifyEvent;
begin
  Result := FButtonDown.OnClick;
end;

procedure TPDJScrollBar.SetOnButtonDownClick(Value: TNotifyEvent);
begin

FButtonDown.OnClick:= value;
end;

procedure TPDJScrollBar.CMMouseEnter(var AMsg: TMessage);
begin
if Assigned(FOnMouseOver) then FOnMouseOver(Self);
end;

procedure TPDJScrollBar.CMMouseLeave(var AMsg: TMessage);
begin
if Assigned(FOnMouseOut) then FOnMouseOut(Self);
end;

procedure TPDJScrollBar.SetStep(value:TStep);
begin
if FStep<>value then
Fstep:=value;
if (csDesigning in ComponentState) and not (csLoading in ComponentState) then
 begin
 if FStep>Max then FStep:=Max;
 end;
end;


function  TPDJScrollBar.GetBojaSetaca:TColor;
begin
  Result := FScroller.BojaSetaca;
end;

procedure TPDJScrollBar.SetBojaSetaca(value:TColor);
begin
 FScroller.BojaSetaca := Value;
end;

function  TPDJScrollBar.GetBojaTrake:TColor;
begin
  Result := FScroller.BojaTrake;
end;

procedure TPDJScrollBar.SetBojaTrake(value:TColor);
begin
 FScroller.BojaTrake := Value;
end;   

function  TPDJScrollBar.GetThumbSize:Tkoliki;
begin
  Result := FScroller.ThumbSize;
end;

procedure TPDJScrollBar.SetThumbSize(value:Tkoliki);
begin
 FScroller.ThumbSize := Value;
end;

function TPDJScrollBar.GetOnChange: TOnScroll;
begin
  Result := FScroller.OnScroll;
end;

procedure TPDJScrollBar.SetOnChange(Value: TOnScroll);
begin
 FScroller.onScroll := Value;
end;

function TPDJScrollBar.GetPosition:integer;
begin
  Result := FScroller.Position;
end;

procedure TPDJScrollBar.SetPosition(value:integer);
begin
    FScroller.Position := Value;
end;

function  TPDJScrollBar.GetTrk:TTrk;
begin

if csDesigning in ComponentState then
 begin
 if FScroller.Trk>Max then FScroller.Trk:=Max;
 end;

  Result := FScroller.Trk;

end;

procedure TPDJScrollBar.SetTrk(value:TTrk);
begin
    FScroller.Trk := Value;

end;


function TPDJScrollBar.GetMin:integer;
begin
     if csDesigning in ComponentState then
 begin

 if FScroller.FMin>max then begin FScroller.FMin:=max;
 end;
 end;

  Result := FScroller.Min;

end;

procedure TPDJScrollBar.SetMin(value:integer);
begin
    FScroller.Min := Value;
end;

function TPDJScrollBar.GetMax:integer;
begin
  Result := FScroller.Max;
end;

procedure TPDJScrollBar.SetMax(value:integer);
begin
    FScroller.Max := Value;
end;



procedure TPDJScrollBar.SetKindd(value:TKindd);
var
  i: Integer;
begin
if FKindd <> Value then
begin
FKindd := Value;
if FKindd=tbHorizontal then
FScroller.SetKind(sbHorizontal)
else
FScroller.SetKind(sbVertical);
SendMessage(Handle, WM_Size, 0, 0);
if (csDesigning in ComponentState) and not (csLoading in ComponentState) then
    begin
      i := Width;
      Width := Height;
      Height := i;
    end;
end;
end;

procedure TPDJScrollBar.CmEnabledChanged(var Message: TWmNoParams);
begin
  inherited;
  FbuttonUp.Enabled:=Enabled;
  FbuttonDown.Enabled:=Enabled;
end;


procedure TPDJScrollBar.WMSetFocus(var Message: TWMSetFocus);
begin
FScroller.FSetac.BevelInner:=bvLowered;
end;

procedure TPDJScrollBar.WMKillFocus(var Message: TWMKillFocus);
begin
FScroller.FSetac.BevelInner:=bvNone;
end;


procedure TPDJScrollBar.DoEnter;
begin
  inherited DoEnter;
end;

procedure TPDJScrollBar.DoExit;
begin
  inherited DoExit;
end;

procedure TPDJScrollBar.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_UP) or (Key = VK_LEFT)then FbuttonUp.doRepeat(Self)
  else if (Key = VK_DOWN) or (Key = VK_RIGHT) then FbuttonDown.doRepeat (Self);
  if (Key = VK_Home) then GetMinic(Self);
  if (Key = VK_End) then GetMaxic(Self);
  if (Key = VK_PRIOR) then GetTrkMinus(Self);
  if (Key = VK_NEXT) then GetTrkPlus(Self);
  inherited KeyDown(Key, Shift);
end;

procedure TPDJScrollBar.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTARROWS;
end;

procedure TPDJScrollBar.GetMinic(Sender:Tobject);
begin
Position:=Min;
FScroller.DoPositionChange;
end;

procedure TPDJScrollBar.GetMaxic(Sender:Tobject);
begin
Position:=Max;
FScroller.DoPositionChange;
end;

procedure TPDJScrollBar.GetTrkPlus(Sender:Tobject);
begin
Position:=Position+LargeChange;
FScroller.DoPositionChange;
end;

procedure TPDJScrollBar.GetTrkMinus(Sender:Tobject);
begin
Position:=Position-LargeChange;
FScroller.DoPositionChange;
end;




//*****************************************************************************
{ TSetac }


procedure TSetac.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  iTop: Integer;
begin
if (ssleft in shift) then begin

if ((TScroller(Parent).Fmin)=(TScroller(Parent).Fmax)) and
((TScroller(Parent).Fmax)=(TScroller(Parent).Fposition)) then exit;

  if TScroller(Parent).Kind = sbVertical then
  begin
    FTopLimit := 0;
    FBottomLimit := TScroller(Parent).Height;
    if FDown = True then
    begin
      iTop := Top + Y - FOldY;
      if iTop < FTopLimit then
      begin
        iTop := FTopLimit;
      end;
      if (iTop > FBottomLimit) or ((iTop + Height) > FBottomLimit) then
      begin
        iTop := FBottomLimit - Height;
      end;
      Top := iTop;
    end;
  end
  else
  begin
    FTopLimit :=0;
    FBottomLimit := TScroller(Parent).Width;
    if FDown = True then
    begin
      iTop := Left + X - FOldX;
      if iTop < FTopLimit then
      begin
        iTop := FTopLimit;
      end;
      if (iTop > FBottomLimit) or ((iTop + Width) > FBottomLimit) then
      begin
        iTop := FBottomLimit - Width;
      end;
      Left := iTop;
    end;
  end;   
    TScroller(Parent).FPosition := TScroller(Parent).PositionFromThumb;
    TScroller(Parent).DoPositionChange;
  inherited MouseMove(Shift,X,Y);
end;    end;


procedure TSetac.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbleft) then begin
  FDown := False;
   end;
  inherited MouseUp(Button,Shift,X,Y);
end; 

procedure TSetac.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbleft) and not FDown then begin FDown := True;
  FOldX := X;
  FOldy := Y; end;
  inherited MouseDown(Button,Shift,X,Y);
end;


//**************************************************

constructor TScroller.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
FKind:=sbHorizontal;
BevelOuter:=bvNone;
FMin := 0;
FMax :=100;
ControlStyle:= ControlStyle - [csAcceptsControls];

Ftrk:=1;
Fkoliki:=25;
FBojaSetaca:=clBtnFace;
FBojaTrake:= cl3DLight;

FTraka:=TTraka.Create(Self);
FTraka.ControlStyle:= ControlStyle - [csAcceptsControls];
FTraka.Align:=alClient;
FTraka.BevelOuter:=bvNone;

ftraka.Color:=FBojatrake;
InsertControl(FTraka);

FSetac := TSetac.Create(Self);
FSetac.ControlStyle:= ControlStyle - [csAcceptsControls];

FSetac.ParentFont:=true;
FSetac.BevelOuter:=bvRaised;
InsertControl(FSetac);

end;



destructor TScroller.Destroy;
begin
FSetac.free;
inherited Destroy;
end;

procedure TScroller.WMSize(var Message: TWMSize);
begin
Case FKind of
sbHorizontal:
begin
FSetac.SetBounds(ThumbFromPosition,0,Fkoliki,Height);
FTraka.Align:=alClient;
end;
sbVertical:
begin
FSetac.SetBounds(0,ThumbFromPosition,Width,Fkoliki);
FTraka.Align:=alClient;
end;
end;
Position := FPosition;
end;


procedure TScroller.SetTrk(value:TTrk);
begin
if FTrk<>value then
 FTrk:=value;
end;


procedure TScroller.SetBojaSetaca(ABojaSetaca:TColor);
begin
FBojaSetaca:=ABojaSetaca;
FSetac.Color:=FBojaSetaca;
end;

procedure TScroller.SetBojaTrake(ABojaTrake:TColor);
begin
FBojaTrake:=ABojaTrake;
ftraka.Color:=FBojatrake;

end;



procedure TScroller.SetKoliki(value:Tkoliki);
begin
 if Fkoliki <> Value then
begin
Fkoliki := Value;

Case FKind of
sbHorizontal:
FSetac.width:=Fkoliki;
sbVertical:
FSetac.height:=Fkoliki;
end;
end;
end;




procedure TScroller.SetKind(value:TKind);
var
  i: Integer;
begin
 if FKind <> Value then
begin
FKind := Value;
if (csDesigning in ComponentState) and not (csLoading in ComponentState) then
    begin
      i := Width;
      Width := Height;
      Height := i;
    end;
end;
end;


function TScroller.ThumbFromPosition: Integer;
var
  iHW, iMin, iMax, iPosition: Integer;
begin
  iHW := 0;
  case FKind of
   sbVertical: iHW := Height - FSetac.Height;
    sbHorizontal: iHW := Width- FSetac.Width;
  end;
  iMin := FMin;
  iMax := FMax;
  iPosition := FPosition;
   if iPosition > iMin then
 Result :=Round(((iPosition-iMin) / Abs(iMax-iMin)) * iHW) else Result :=0;
end;


function TScroller.PositionFromThumb: Integer;
var
  iHW, iMin, iMax, iPosition: Integer;
begin
 iHW := 0;
 case FKind of
   sbVertical: iHW :=  Height - FSetac.Height;
   sbHorizontal: iHW :=Width - FSetac.Width;
  end;
  iMin := FMin;
  iMax := FMax;
  iPosition := 0;
 case FKind of
   sbVertical: iPosition := FSetac.Top;
    sbHorizontal: iPosition := FSetac.Left;
 end;
Result := Round(iPosition / iHW * Abs(iMax - iMin))+imin;
end;

procedure TScroller.DoPositionChange;
begin
TPDJScrollBar(parent).SetFocus;
 FPosition := Position;
  DoScroll;
end;

procedure TScroller.DoScroll;
begin
  if Assigned(FOnScroll) then FOnScroll(Self,Position);
end;

procedure TScroller.SetPosition(Value: Integer);
begin
  FPosition := Value;
     if FPosition<0 then FPosition:=0;
     if FPosition>Fmax then FPosition:=Fmax;
     if FPosition<FMin then FPosition:=FMin;
 case FKind of
    sbVertical: FSetac.Top := ThumbFromPosition;
    sbHorizontal: FSetac.Left := ThumbFromPosition;
    end;
  end;

procedure TScroller.SetMin(Value: Integer);
begin
  if Value <> FMin then
  begin
  FMin := Value;
    if FMin>FPosition then FPosition:=FMin;

    if FPosition>Fmax then FPosition:=Fmax;
    case FKind of
    sbVertical: FSetac.Top := ThumbFromPosition;
    sbHorizontal: FSetac.Left := ThumbFromPosition;
    end;
 end;
  end;


procedure TScroller.SetMax(Value: Integer);
begin
 if Value <> FMax then
  begin
    FMax := Value;
    if FMax<Fposition then Fmax:=FPosition;
    case FKind of
    sbVertical: FSetac.Top := ThumbFromPosition;
    sbHorizontal: FSetac.Left := ThumbFromPosition;
    end;
  end;
  end;

//*****************************************************************************

{TButtonUp}

constructor TButtonUp.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FRepeat:=TTimer.Create(Self);
 FRepeat.Enabled:=false;
 FRepeat.Interval:=50;
 FRepeat.OnTimer:=doRepeat;
 FStart:=TTimer.Create(Self);
 FStart.Enabled:=false;
 FStart.Interval:=50;
 FStart.OnTimer:=doStart;
end;

procedure TbuttonUp.WMLButtonDblClk (var Message: TWMLButtonDown);
begin
  inherited;
end;

procedure TbuttonUp.Click;
begin
 TPDJScrollBar(parent).position:=TPDJScrollBar(parent).position-TPDJScrollBar(parent).SmallChange;
 TPDJScrollBar(parent).FScroller.DoPositionChange;
 inherited ;
end;

procedure TButtonUp.doRepeat(Sender: TObject);
begin
Click;
end;

procedure TButtonUp.doStart(Sender: TObject);
begin
 FStart.Enabled:=false;
 FRepeat.Enabled:=true;
end;


procedure TButtonUp.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin

 if Button<>mbleft then exit else begin
 FStart.Enabled:=true;
 end;
 inherited MouseDown(Button, Shift, X, Y);
end;

procedure TButtonUp.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
 if Button<>mbleft then exit else begin
 FRepeat.Enabled:=false;
 FStart.Enabled:=false; end;
 inherited MouseUp(Button, Shift, X, Y);
end;

//*****************************************************************************
{TButtonDown}

constructor TButtonDown.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FRepeat:=TTimer.Create(Self);
 FRepeat.Enabled:=false;
 FRepeat.Interval:=50;
 FRepeat.OnTimer:=doRepeat;
 FStart:=TTimer.Create(Self);
 FStart.Enabled:=false;
 FStart.Interval:=50;
 FStart.OnTimer:=doStart;
end;


procedure TbuttonDown.WMLButtonDblClk (var Message: TWMLButtonDown);
begin
  inherited;
end;

procedure TbuttonDown.Click;
begin
 TPDJScrollBar(parent).position:=TPDJScrollBar(parent).position+TPDJScrollBar(parent).SmallChange;
 TPDJScrollBar(parent).FScroller.DoPositionChange;
 inherited ;
end;

procedure TButtonDown.doRepeat(Sender: TObject);
begin
Click;
end;

procedure TButtonDown.doStart(Sender: TObject);
begin
 FStart.Enabled:=false;
 FRepeat.Enabled:=true;
end;


procedure TButtonDown.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
 if Button<>mbleft then exit else begin
 FStart.Enabled:=true;
  end;
  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TButtonDown.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
 if Button<>mbleft then exit else begin
 FRepeat.Enabled:=false;
 FStart.Enabled:=false; end;
 inherited MouseUp(Button, Shift, X, Y);
end;


destructor TButtonDown.Destroy;
begin
 FRepeat.free;
 FStart.free;
 inherited Destroy;
end;

destructor TButtonUp.Destroy;
begin
 FRepeat.free;
 FStart.free;
 inherited Destroy;
end;

//*****************************************************************************

{TTraka}

constructor TTraka.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FRepeat:=TTimer.Create(Self);
 FRepeat.Enabled:=false;
 FRepeat.Interval:=50;
 FRepeat.OnTimer:=doRepeat;
 FStart:=TTimer.Create(Self);
 FStart.Enabled:=false;
 FStart.Interval:=50;
 FStart.OnTimer:=doStart;
end;

destructor TTraka.Destroy;
begin
 FRepeat.free;
 FStart.free;
 inherited Destroy;
end;

procedure TTraka.WMLButtonDblClk (var Message: TWMLButtonDown);
begin
  inherited;
end;

procedure TTraka.Click;
begin
if (TScroller(parent).Fkind=sbhorizontal) and (FXX<TScroller(parent).FSetac.Left) then
TScroller(parent).position:=TScroller(parent).position- TScroller(parent).Trk;
if (TScroller(parent).Fkind=sbhorizontal) and (FXX>(TScroller(parent).FSetac.Left+TScroller(parent).FSetac.width)) then
TScroller(parent).position:=TScroller(parent).position+TScroller(parent).Trk;
if (TScroller(parent).Fkind=sbvertical) and (FYY<TScroller(parent).FSetac.top) then
TScroller(parent).position:=TScroller(parent).position- TScroller(parent).Trk;
if (TScroller(parent).Fkind=sbvertical) and (FYY>(TScroller(parent).FSetac.Top+TScroller(parent).FSetac.height)) then
TScroller(parent).position:=TScroller(parent).position+TScroller(parent).Trk;
TScroller(parent).DoPositionChange;
 inherited ;
end;


procedure TTraka.doRepeat(Sender: TObject);
begin
Click;
end;

procedure TTraka.doStart(Sender: TObject);
begin
 FStart.Enabled:=false;
 FRepeat.Enabled:=true;
end;


procedure TTraka.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin

 if Button<>mbleft then exit else begin
 FStart.Enabled:=true;
 FXX:=X;
 FYY:=Y;
 end;
 inherited MouseDown(Button, Shift, X, Y);
end;

procedure TTraka.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
 if Button<>mbleft then exit else begin
 FRepeat.Enabled:=false;
 FStart.Enabled:=false; end;
 inherited MouseUp(Button, Shift, X, Y);
end;

procedure TTraka.CMMouseLeave(var AMsg: TMessage);
begin
 FRepeat.Enabled:=false;
 FStart.Enabled:=false; 
end;

//*****************************************************************************
{TMail}

  procedure TMail.click;
var
  AnUrl: array[0..255] of char;
begin
  StrPCopy(AnUrl, 'mailto:'+'pericddn@ptt.yu');
  ShellExecute(Application.Handle, 'open', AnUrl, nil, nil, SW_NORMAL);
  Font.color:=clMaroon;
end;

//*****************************************************************************
{TOK}

  procedure TOK.click;
begin
 AMsgDialog.Close;
end;

//*****************************************************************************

{TAbout}

function TAboutBoxEditor.GetAttributes;
begin
	Result := inherited GetAttributes +
				[paDialog]+[paReadOnly];
end;


function TAboutBoxEditor.GetValue: string;
begin
	Result := 'version 1.00';
end;


Procedure TAboutBoxEditor.Edit;
var
AOK:TOK;

AImage,AZnak:TImage;
ALabelime,ALabelverzija,ALabelcopy:Tlabel;
ALabelmail:TMail;
APanel:TPanel;

begin
  AMsgDialog :=TForm.Create( Application );
  Aimage := Timage.Create(AMsgDialog);
  AZnak := Timage.Create(AMsgDialog);
  ALabelime := TLabel.Create(AMsgDialog);
  ALabelverzija := TLabel.Create(AMsgDialog);
  ALabelcopy := TLabel.Create(AMsgDialog);
  ALabelmail := TMail.Create(AMsgDialog);
  APanel := TPanel.Create(AMsgDialog);
  AOK := TOK.Create(AMsgDialog);
  with AMsgDialog do
try
      Caption := 'About...' ;
      Height := 185;
      Width:=226;
      Position:= poScreenCenter;
      BorderStyle:=bsDialog;

with AImage do
begin
Parent := AMsgDialog;
Bmp := TBitmap.Create;
Bmp.Handle := LoadBitmap(hInstance, 'ABOUTScrollBar');
Picture.Assign(BMP);
Left := 8;
Top := 80;
Width := 37;
Height := 37;
Center := True;
Transparent:=True;
end;
with AOK do
begin
    Parent := AMsgDialog;
    Left := 140;
    Top := 132;
    Width := 75;
    Height := 25;
    Caption := 'OK';
    Default:=True;
    TabOrder:=0;
end;

with ALabelCopy do
begin
    Parent := AMsgDialog;
    Left := 60;
    Top := 80;
    Width := 151;
    Height := 13;
    Caption := 'Copyright  2000-2001 by Peric';
end;

with ALabelMail do
begin
    cursor := crHandPoint;
    Parent := AMsgDialog;
    Left := 60;
    Top := 100;
    Width := 112;
    Height := 13;
    Caption := 'E-Mail: pericddn@ptt.yu';
    Font.Color:=clBlue;
    Font.Style := [fsUnderline];
end;

with ALabelverzija do
begin
    Parent := AMsgDialog;
    Left := 100;
    Top := 44;
    Width := 84;
    Height := 16;
    Caption := 'version 1.00';
    Font.Size:=10;
    Font.Style := [fsBold];
end;

with ALabelime do
begin
    Parent := AMsgDialog;
    Left := 45;
    Top := 4;
    Width := 141 ;
    Height := 29;
    Caption := 'PDJScrollBar';
    Font.Size:=18;
    Font.Style := [fsBold];
    Font.Color:=clBlue;
end;

with AZnak do
begin
Parent := AMsgDialog;
Bmp := TBitmap.Create;
Bmp.Handle := LoadBitmap(hInstance, 'TPDJScrollBar');
Picture.Assign(BMP);
Left := 8;
Top := 8;
Width := 26;
Height := 26;
Center := True;
Transparent:=True;
end;

with APanel do
begin
    Parent := AMsgDialog;
    Left := 4;
    Top := 68;
    Width := 209 ;
    Height := 2;
    BevelOuter := bvLowered;
end;



if (ShowModal = ID_YES) then
begin
       end;
finally
AOK.Free;
AZnak.Free;
ALabelime.Free;
AImage.Free;
ALabelverzija.Free;
ALabelCopy.Free;
ALabelMail.Free;
BMP.Free;
Free;    
end;
end;


end.
